"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard")["default"];

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.CarouselTheme = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _createSuper2 = _interopRequireDefault(require("@babel/runtime/helpers/createSuper"));

var _react = _interopRequireWildcard(require("react"));

var _debounce = _interopRequireDefault(require("lodash/debounce"));

var _classnames = _interopRequireDefault(require("classnames"));

var _mediaQueryListPolyfill = require("../_util/mediaQueryListPolyfill");

var _ConfigContext = _interopRequireDefault(require("../config-provider/ConfigContext"));

// matchMedia polyfill for
// https://github.com/WickyNilliams/enquire.js/issues/82
if (typeof window !== 'undefined') {
  // const matchMediaPolyfill = (mediaQuery: string): MediaQueryList => {
  //   return {
  //     media: mediaQuery,
  //     matches: false,
  //     addListener() {
  //     },
  //     removeListener() {
  //     },
  //   };
  // };
  window.matchMedia = window.matchMedia || _mediaQueryListPolyfill.matchMediaPolifill;
} // Use require over import (will be lifted up)
// make sure matchMedia polyfill run before require('react-slick')
// eslint-disable-next-line @typescript-eslint/no-var-requires


var SlickCarousel = require('react-slick')["default"];

var CarouselTheme;
exports.CarouselTheme = CarouselTheme;

(function (CarouselTheme) {
  CarouselTheme["DARK"] = "dark";
  CarouselTheme["LIGHT"] = "light";
})(CarouselTheme || (exports.CarouselTheme = CarouselTheme = {}));

var Carousel = /*#__PURE__*/function (_Component) {
  (0, _inherits2["default"])(Carousel, _Component);

  var _super = (0, _createSuper2["default"])(Carousel);

  function Carousel() {
    var _this;

    (0, _classCallCheck2["default"])(this, Carousel);
    _this = _super.apply(this, arguments);
    _this.onWindowResized = (0, _debounce["default"])(function () {
      var autoplay = _this.props.autoplay;

      if (autoplay && _this.slick && _this.slick.innerSlider && _this.slick.innerSlider.autoPlay) {
        _this.slick.innerSlider.autoPlay();
      }
    }, 500, {
      leading: false
    });

    _this.handleArrowMouseChange = function (event) {
      var pauseOnArrowsHover = _this.props.pauseOnArrowsHover;

      if (pauseOnArrowsHover) {
        if (event.type === 'mouseleave') {
          _this.play();
        } else if (event.type === 'mouseenter') {
          _this.pause();
        }
      }
    };

    _this.saveSlick = function (node) {
      _this.slick = node;
    };

    return _this;
  }

  (0, _createClass2["default"])(Carousel, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var autoplay = this.props.autoplay;

      if (autoplay) {
        window.addEventListener('resize', this.onWindowResized);
      }

      if (this.wrapper) {
        this.arrowsRef = this.wrapper.querySelectorAll('.slick-slider .slick-arrow');
        this.dotsRef = this.wrapper.querySelectorAll('.slick-slider .slick-dots li');
      }

      this.bindDotsEvent();
      this.bindArrowEvent();
      this.innerSlider = this.slick && this.slick.innerSlider;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this2 = this;

      var autoplay = this.props.autoplay;

      if (autoplay) {
        window.removeEventListener('resize', this.onWindowResized);
        this.onWindowResized.cancel();
      }

      if (this.dotsRef) {
        this.dotsRef.forEach(function (dot, i) {
          dot.removeEventListener('mouseenter', function () {
            return _this2.handleDotsHover(i);
          });
        });
      }

      if (this.arrowsRef) {
        this.arrowsRef.forEach(function (arrow) {
          arrow.removeEventListener('mouseenter', _this2.handleArrowMouseChange);
          arrow.removeEventListener('mouseleave', _this2.handleArrowMouseChange);
        });
      }
    }
  }, {
    key: "bindDotsEvent",
    value: function bindDotsEvent() {
      var _this3 = this;

      if (this.wrapper) {
        this.dotsRef.forEach(function (dot, i) {
          dot.addEventListener('mouseenter', function () {
            return _this3.handleDotsHover(i);
          });
        });
      }
    }
  }, {
    key: "bindArrowEvent",
    value: function bindArrowEvent() {
      var _this4 = this;

      var autoplay = this.props.autoplay;

      if (this.arrowsRef && autoplay) {
        this.arrowsRef.forEach(function (arrow) {
          arrow.addEventListener('mouseenter', _this4.handleArrowMouseChange);
          arrow.addEventListener('mouseleave', _this4.handleArrowMouseChange);
        });
      }
    }
  }, {
    key: "handleDotsHover",
    value: function handleDotsHover(index) {
      var dotsActionType = this.props.dotsActionType;

      if (dotsActionType && dotsActionType.includes('hover')) {
        this.goTo(index, true);
      }
    }
  }, {
    key: "play",
    value: function play() {
      this.slick.slickPlay();
    }
  }, {
    key: "pause",
    value: function pause() {
      this.slick.slickPause();
    }
  }, {
    key: "next",
    value: function next() {
      this.slick.slickNext();
    }
  }, {
    key: "prev",
    value: function prev() {
      this.slick.slickPrev();
    }
  }, {
    key: "goTo",
    value: function goTo(slide, dontAnimate) {
      this.slick.slickGoTo(slide, dontAnimate);
    }
  }, {
    key: "render",
    value: function render() {
      var _classNames,
          _this5 = this;

      var getPrefixCls = this.context.getPrefixCls;
      var dotsClass = this.props.dotsClass;
      var props = (0, _objectSpread2["default"])({}, this.props);

      if (dotsClass) {
        props.dotsClass = ["slick-dots", dotsClass].join(' ');
      }

      if (props.effect === 'fade') {
        props.fade = true;
      }

      var prefixCls = getPrefixCls('carousel', props.prefixCls);
      var className = (0, _classnames["default"])(prefixCls, (_classNames = {}, (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-vertical"), props.vertical), (0, _defineProperty2["default"])(_classNames, "".concat(prefixCls, "-theme-dark"), props.theme === CarouselTheme.DARK), _classNames));
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: className,
        ref: function ref(wrapper) {
          _this5.wrapper = wrapper;
        }
      }, /*#__PURE__*/_react["default"].createElement(SlickCarousel, (0, _extends2["default"])({
        ref: this.saveSlick
      }, props)));
    }
  }], [{
    key: "contextType",
    get: function get() {
      return _ConfigContext["default"];
    }
  }]);
  return Carousel;
}(_react.Component);

exports["default"] = Carousel;
Carousel.displayName = 'Carousel';
Carousel.defaultProps = {
  dots: true,
  arrows: false,
  draggable: false,
  theme: CarouselTheme.LIGHT,
  pauseOnDotsHover: true,
  pauseOnArrowsHover: true,
  dotsActionType: ["click"]
};
//# sourceMappingURL=index.js.map
